Index: issm/trunk-jpl/externalpackages/chaco/chaco.patch
===================================================================
--- issm/trunk-jpl/externalpackages/chaco/chaco.patch	(revision 28138)
+++ issm/trunk-jpl/externalpackages/chaco/chaco.patch	(revision 28143)
@@ -1,12 +1,12 @@
 Only in src/code/assign: assign.o
 diff -rc src/code/assign/assign_out.c old/code/assign/assign_out.c
-*** src/code/assign/assign_out.c  2010-07-16 16:28:47.352242454 -0700
---- old/code/assign/assign_out.c  1995-08-08 14:32:10.000000000 -0700
+*** src/code/assign/assign_out.c	2010-07-16 16:28:47.352242454 -0700
+--- old/code/assign/assign_out.c	1995-08-08 14:32:10.000000000 -0700
 ***************
 *** 3,9 ****
    * contract DE-AC04-76DP00789 and is copyrighted by Sandia Corporation. */
   
-  #include  <stdio.h>
-- #include  "defs.h"
+  #include	<stdio.h>
+- #include	"defs.h"
   
   static void assign_out_normal(), assign_out_inv();
@@ -54,6 +54,6 @@
 Only in src/code/eigen: eigensolve.o
 diff -rc src/code/eigen/get_extval.c old/code/eigen/get_extval.c
-*** src/code/eigen/get_extval.c 2010-07-16 16:28:47.353242463 -0700
---- old/code/eigen/get_extval.c 1995-08-08 14:32:20.000000000 -0700
+*** src/code/eigen/get_extval.c	2010-07-16 16:28:47.353242463 -0700
+--- old/code/eigen/get_extval.c	1995-08-08 14:32:20.000000000 -0700
 ***************
 *** 4,10 ****
@@ -143,6 +143,6 @@
 Only in src/code/klvspiff: make_sep_list.o
 diff -rc src/code/klvspiff/matching.c old/code/klvspiff/matching.c
-*** src/code/klvspiff/matching.c  2010-07-16 16:28:47.356242493 -0700
---- old/code/klvspiff/matching.c  1996-03-11 10:24:25.000000000 -0800
+*** src/code/klvspiff/matching.c	2010-07-16 16:28:47.356242493 -0700
+--- old/code/klvspiff/matching.c	1996-03-11 10:24:25.000000000 -0800
 ***************
 *** 6,12 ****
@@ -158,6 +158,6 @@
 Only in src/code/klvspiff: nway_klv.o
 diff -rc src/code/main/defs.h old/code/main/defs.h
-*** src/code/main/defs.h  2010-07-16 16:28:47.359242522 -0700
---- old/code/main/defs.h  1995-08-08 14:32:41.000000000 -0700
+*** src/code/main/defs.h	2010-07-16 16:28:47.359242522 -0700
+--- old/code/main/defs.h	1995-08-08 14:32:41.000000000 -0700
 ***************
 *** 1,39 ****
@@ -165,36 +165,36 @@
 ! #define _CHACO_DEFS_H_
 ! 
-  #define TRUE    1
-  #define FALSE   0
+  #define TRUE		1
+  #define FALSE		0
   
 ! #ifndef _HAVE_CHACO_ //protect ISSM compilation. This symbol is defined when we compile ISSM
 ! 
-!   #define max(A, B) ((A) > (B) ? (A) : (B))
-!   #define min(A, B) ((A) < (B) ? (A) : (B))
-!   #define sign(A)   ((A) <  0  ? -1  :  1)
-!   #define absval(A) ((A) <  0  ? -(A): (A))
-! 
-!   /* Define constants that are needed in various places */
-!   #define PI  3.141592653589793
-!   #define TWOPI 6.283185307179586
-!   #define HALFPI  1.570796326794896
+! 	#define	max(A, B)	((A) > (B) ? (A) : (B))
+! 	#define	min(A, B)	((A) < (B) ? (A) : (B))
+! 	#define sign(A)		((A) <  0  ? -1  :  1)
+! 	#define absval(A)	((A) <  0  ? -(A): (A))
+! 
+! 	/* Define constants that are needed in various places */
+! 	#define	PI	3.141592653589793
+! 	#define	TWOPI	6.283185307179586
+! 	#define HALFPI  1.570796326794896
 ! 
 !     #define check_graph chaco_check_graph
 ! 
 ! 
-!   #ifdef MATLAB
-!     #include "mat.h"
-!     #include "mex.h"
-!     #include "matrix.h"
-!      
-!     #define printf mexPrintf
-!     #define fprintf(file,...) (file == stdout || file == stderr ? mexPrintf(__VA_ARGS__) : fprintf(file,__VA_ARGS__))
-!     #define malloc mxMalloc
-!     #define calloc mxCalloc
-!     #define realloc mxRealloc
-!     #define free mxFree
-!     #define exit(status) mexErrMsgTxt("exit=" #status)
-! 
-!   #endif
+! 	#ifdef MATLAB
+! 		#include "mat.h"
+! 		#include "mex.h"
+! 		#include "matrix.h"
+! 	   
+! 		#define printf mexPrintf
+! 		#define fprintf(file,...) (file == stdout || file == stderr ? mexPrintf(__VA_ARGS__) : fprintf(file,__VA_ARGS__))
+! 		#define malloc mxMalloc
+! 		#define calloc mxCalloc
+! 		#define realloc mxRealloc
+! 		#define free mxFree
+! 		#define exit(status) mexErrMsgTxt("exit=" #status)
+! 
+! 	#endif
 ! 
 ! #endif  //#ifndef _HAVE_CHACO_ 
@@ -202,20 +202,20 @@
 ! #endif //ifndef _CHACO_DEFS_H_
 --- 1,11 ----
-! #define max(A, B) ((A) > (B) ? (A) : (B))
-! #define min(A, B) ((A) < (B) ? (A) : (B))
-! #define sign(A)   ((A) <  0  ? -1  :  1)
-! #define absval(A) ((A) <  0  ? -(A): (A))
-  #define TRUE    1
-  #define FALSE   0
+! #define	max(A, B)	((A) > (B) ? (A) : (B))
+! #define	min(A, B)	((A) < (B) ? (A) : (B))
+! #define sign(A)		((A) <  0  ? -1  :  1)
+! #define absval(A)	((A) <  0  ? -(A): (A))
+  #define TRUE		1
+  #define FALSE		0
   
 ! /* Define constants that are needed in various places */
-! #define PI  3.141592653589793
-! #define TWOPI 6.283185307179586
+! #define	PI	3.141592653589793
+! #define	TWOPI	6.283185307179586
 ! #define HALFPI  1.570796326794896
 Only in src/code/main: interface.o
 Only in src/code/main: main.o
 diff -rc src/code/main/params.h old/code/main/params.h
-*** src/code/main/params.h  2010-07-16 16:28:47.361242541 -0700
---- old/code/main/params.h  1995-08-08 14:32:43.000000000 -0700
+*** src/code/main/params.h	2010-07-16 16:28:47.361242541 -0700
+--- old/code/main/params.h	1995-08-08 14:32:43.000000000 -0700
 ***************
 *** 1,12 ****
@@ -224,9 +224,9 @@
 - 
 - 
-  #define NAME_LENGTH 80  /* Maximum length of file name */
-  #define LINE_LENGTH 200 /* Length of input files read at once */
-  
-  #define MAXDIMS   3 /* Most cuts allowed at one time */
-  #define MAXSETS   8 /* 2^MAXDIMS */
+  #define NAME_LENGTH	80	/* Maximum length of file name */
+  #define LINE_LENGTH	200	/* Length of input files read at once */
+  
+  #define MAXDIMS		3	/* Most cuts allowed at one time */
+  #define MAXSETS		8	/* 2^MAXDIMS */
 - 
 - 
@@ -252,6 +252,6 @@
 Only in src/code/misc: time_kernels.o
 diff -rc src/code/misc/timing.c old/code/misc/timing.c
-*** src/code/misc/timing.c  2010-07-16 16:28:47.366242590 -0700
---- old/code/misc/timing.c  1997-01-03 09:10:52.000000000 -0800
+*** src/code/misc/timing.c	2010-07-16 16:28:47.366242590 -0700
+--- old/code/misc/timing.c	1997-01-03 09:10:52.000000000 -0800
 ***************
 *** 3,9 ****
@@ -297,6 +297,6 @@
 Only in src/code/symmlq: pow_dd.o
 diff -rc src/code/symmlq/symmlqblas.f old/code/symmlq/symmlqblas.f
-*** src/code/symmlq/symmlqblas.f  2010-07-21 18:09:10.370123273 -0700
---- old/code/symmlq/symmlqblas.f  2010-07-21 14:02:09.633743650 -0700
+*** src/code/symmlq/symmlqblas.f	2010-07-21 18:09:10.370123273 -0700
+--- old/code/symmlq/symmlqblas.f	2010-07-21 14:02:09.633743650 -0700
 ***************
 *** 16,22 ****
@@ -324,12 +324,12 @@
 Only in src/code/util: array_alloc_2D.o
 diff -rc src/code/util/bail.c old/code/util/bail.c
-*** src/code/util/bail.c  2010-07-16 16:28:47.368242609 -0700
---- old/code/util/bail.c  1995-08-08 14:33:01.000000000 -0700
+*** src/code/util/bail.c	2010-07-16 16:28:47.368242609 -0700
+--- old/code/util/bail.c	1995-08-08 14:33:01.000000000 -0700
 ***************
 *** 4,10 ****
   
-  #include  <stdio.h>
-  #include  <string.h>
-- #include  "defs.h"
+  #include	<stdio.h>
+  #include	<string.h>
+- #include	"defs.h"
   
   /* Wrapper for exit() - print message and exit with status code. Exit code
@@ -341,5 +341,5 @@
   int       status;
   {
-      extern FILE *Output_File;   /* Output file or NULL */
+      extern FILE *Output_File;		/* Output file or NULL */
 +     void      exit();
   
@@ -349,12 +349,12 @@
 Only in src/code/util: bit_reverse.o
 diff -rc src/code/util/checkpnt.c old/code/util/checkpnt.c
-*** src/code/util/checkpnt.c  2010-07-16 16:28:47.370242629 -0700
---- old/code/util/checkpnt.c  1995-08-08 14:33:01.000000000 -0700
+*** src/code/util/checkpnt.c	2010-07-16 16:28:47.370242629 -0700
+--- old/code/util/checkpnt.c	1995-08-08 14:33:01.000000000 -0700
 ***************
 *** 4,10 ****
   
-  #include  <stdio.h>
-  #include  <string.h>
-- #include  "defs.h"
+  #include	<stdio.h>
+  #include	<string.h>
+- #include	"defs.h"
   
   /* Debug break point. */
@@ -365,6 +365,6 @@
 Only in src/code/util: dot.o
 diff -rc src/code/util/doubleout.c old/code/util/doubleout.c
-*** src/code/util/doubleout.c 2010-07-16 16:28:47.372242648 -0700
---- old/code/util/doubleout.c 1995-08-08 14:33:02.000000000 -0700
+*** src/code/util/doubleout.c	2010-07-16 16:28:47.372242648 -0700
+--- old/code/util/doubleout.c	1995-08-08 14:33:02.000000000 -0700
 ***************
 *** 3,9 ****
@@ -392,6 +392,6 @@
 Only in src/code/util: shell_sort.o
 diff -rc src/code/util/smalloc.c old/code/util/smalloc.c
-*** src/code/util/smalloc.c 2010-07-16 16:28:47.375242677 -0700
---- old/code/util/smalloc.c 1996-03-11 10:44:07.000000000 -0800
+*** src/code/util/smalloc.c	2010-07-16 16:28:47.375242677 -0700
+--- old/code/util/smalloc.c	1996-03-11 10:44:07.000000000 -0800
 ***************
 *** 4,10 ****
@@ -401,17 +401,17 @@
 - #include "defs.h"
   
-  static int nmalloc = 0;   /* number of calls to malloc */
-  static int nfree = 0;   /* number of calls to free */
+  static int nmalloc = 0;		/* number of calls to malloc */
+  static int nfree = 0;		/* number of calls to free */
 --- 4,9 ----
 Only in src/code/util: smalloc.o
 diff -rc src/code/util/strout.c old/code/util/strout.c
-*** src/code/util/strout.c  2010-07-16 16:28:47.377242697 -0700
---- old/code/util/strout.c  1995-08-08 14:33:05.000000000 -0700
+*** src/code/util/strout.c	2010-07-16 16:28:47.377242697 -0700
+--- old/code/util/strout.c	1995-08-08 14:33:05.000000000 -0700
 ***************
 *** 4,10 ****
   
-  #include  <stdio.h>
-  #include  <string.h>
-- #include  "defs.h"
+  #include	<stdio.h>
+  #include	<string.h>
+- #include	"defs.h"
   
   /* Wrapper for a printf statement with a string as only arg.