Index: issm/trunk-jpl/src/c/shared/Enum/EnumDefinitions.h
===================================================================
--- issm/trunk-jpl/src/c/shared/Enum/EnumDefinitions.h	(revision 28233)
+++ issm/trunk-jpl/src/c/shared/Enum/EnumDefinitions.h	(revision 28234)
@@ -262,4 +262,6 @@
 	HydrologyEnglacialVoidRatioEnum,
 	HydrologyIschannelsEnum,
+	HydrologyIsIncludeSheetThicknessEnum,
+	HydrologyCreepOpenFlagEnum,
 	HydrologyIsTransitionEnum,
 	HydrologyIsWaterPressureArmaEnum,
Index: issm/trunk-jpl/src/m/classes/hydrologyglads.m
===================================================================
--- issm/trunk-jpl/src/m/classes/hydrologyglads.m	(revision 28233)
+++ issm/trunk-jpl/src/m/classes/hydrologyglads.m	(revision 28234)
@@ -15,4 +15,6 @@
 		sheet_beta                = NaN; 
 		rheology_B_base           = NaN;
+		isincludesheetthickness   = 0;
+		creep_open_flag  		  = 1;
 
 		%Channels
@@ -68,4 +70,5 @@
 			self.melt_flag=0;
 			self.istransition = 0; %by default use GlaDS default turbulent code
+			self.creep_open_flag = 1;
 		end % }}}
 		function md = checkconsistency(self,md,solution,analyses) % {{{
@@ -85,4 +88,5 @@
 			md = checkfield(md,'fieldname','hydrology.sheet_beta', 'numel', [1], '>', 0); 
 			md = checkfield(md,'fieldname','hydrology.rheology_B_base','size',[md.mesh.numberofvertices 1],'>=',0,'NaN',1,'Inf',1);
+			md = checkfield(md,'fieldname','hydrology.isincludesheetthickness','numel',[1],'values',[0 1]);
 			%Channels
 			md = checkfield(md,'fieldname','hydrology.ischannels','numel',[1],'values',[0 1]);
@@ -100,4 +104,5 @@
 			md = checkfield(md,'fieldname','hydrology.melt_flag','numel',[1],'values',[0 1 2]);
 			md = checkfield(md,'fieldname','hydrology.istransition','numel',[1],'values',[0 1]);
+			md = checkfield(md,'fieldname','hydrology.creep_open_flag','numel',[1],'values',[0 1]);
 			if self.melt_flag==1 || self.melt_flag==2
 				md = checkfield(md,'fieldname','basalforcings.groundedice_melting_rate','NaN',1,'Inf',1,'timeseries',1);
@@ -115,4 +120,6 @@
 			fielddisplay(self,'omega','transition parameter (omega) []'); 
 			fielddisplay(self,'rheology_B_base','Ice rheology factor B at base of ice (B) [Pa s^(-1/3)]');
+			fielddisplay(self,'isincludesheetthickness','Do we add rho_w*g*h in effective pressure calculation? 1: yes, 0: no');
+			fielddisplay(self,'creep_open_flag','Do we allow cavities to open by creep when N<0? 1: yes, 0: no');
 			disp(sprintf('      CHANNELS'));
 			fielddisplay(self,'ischannels','Do we allow for channels? 1: yes, 0: no');
@@ -146,4 +153,6 @@
 			WriteData(fid,prefix,'object',self,'class','hydrology','fieldname','sheet_beta','format','Double'); 
 			WriteData(fid,prefix,'object',self,'class','hydrology','fieldname','rheology_B_base','format','DoubleMat','mattype',1);
+			WriteData(fid,prefix,'object',self,'class','hydrology','fieldname','isincludesheetthickness','format','Boolean');
+			WriteData(fid,prefix,'object',self,'class','hydrology','fieldname','creep_open_flag','format','Boolean');
 
 			%Channels
Index: issm/trunk-jpl/src/m/classes/hydrologyglads.py
===================================================================
--- issm/trunk-jpl/src/m/classes/hydrologyglads.py	(revision 28233)
+++ issm/trunk-jpl/src/m/classes/hydrologyglads.py	(revision 28234)
@@ -19,8 +19,11 @@
         self.cavity_spacing = 0.
         self.bump_height = np.nan
-        self.omega = 0.;
-        self.sheet_alpha = np.nan; 
-        self.sheet_beta = np.nan; 
-        self.rheology_B_base = np.nan;
+        self.omega = 0.
+        self.sheet_alpha = np.nan 
+        self.sheet_beta = np.nan 
+        self.rheology_B_base = np.nan
+        self.isincludesheetthickness = 0
+        self.creep_open_flag = 1
+        self.rheology_B_base = np.nan
 
         # Channels
@@ -28,6 +31,6 @@
         self.channel_conductivity = np.nan
         self.channel_sheet_width = 0.
-        self.channel_alpha = np.nan; 
-        self.channel_beta = np.nan; 
+        self.channel_alpha = np.nan 
+        self.channel_beta = np.nan 
 
         # Other
@@ -52,5 +55,5 @@
     def __repr__(self):  # {{{
         s = '   GlaDS (hydrologyglads) solution parameters:\n'
-        s = '\t--SHEET\n'
+        s += '\t--SHEET\n'
         s += '{}\n'.format(fielddisplay(self, 'pressure_melt_coefficient', 'Pressure melt coefficient (c_t) [K Pa^ - 1]'))
         s += '{}\n'.format(fielddisplay(self, 'sheet_conductivity', 'sheet conductivity (k) [m^(7 / 4) kg^(- 1 / 2)]'))
@@ -61,5 +64,7 @@
         s += '{}\n'.format(fielddisplay(self, 'omega', 'transition parameter (omega) []')) #TH
         s += '{}\n'.format(fielddisplay(self, 'rheology_B_base', 'ice rheology factor B at base of ice (B) [Pa s^(-1/3)]')) #SE
-        s = '\t--CHANNELS\n'
+        s += '{}\n'.format(fielddisplay(self, 'isincludesheetthickness', 'Do we add rho_w*g*h in effective pressure calculation? 1: yes, 0: no'))
+        s += '{}\n'.format(fielddisplay(self, 'creep_open_flag', 'Do we allow cavities to open by creep when N<0? 1: yes, 0: no'))
+        s += '\t--CHANNELS\n'
         s += '{}\n'.format(fielddisplay(self, 'ischannels', 'Do we allow for channels? 1: yes, 0: no'))
         s += '{}\n'.format(fielddisplay(self, 'channel_conductivity', 'channel conductivity (k_c) [m^(3 / 2) kg^(- 1 / 2)]'))
@@ -67,5 +72,5 @@
         s += '{}\n'.format(fielddisplay(self, 'channel_alpha', 'First channel-flow exponent (alpha_s) []')) #TH
         s += '{}\n'.format(fielddisplay(self, 'channel_beta', 'Second channel-flow exponent (beta_s) []')) #TH
-        s = '\t--OTHER\n'
+        s += '\t--OTHER\n'
         s += '{}\n'.format(fielddisplay(self, 'spcphi', 'Hydraulic potential Dirichlet constraints [Pa]'))
         s += '{}\n'.format(fielddisplay(self, 'neumannflux', 'water flux applied along the model boundary (m^2 / s)'))
@@ -75,5 +80,5 @@
         s += '{}\n'.format(fielddisplay(self, 'melt_flag', 'User specified basal melt? 0: no (default), 1: use md.basalforcings.groundedice_melting_rate'))
         s += '{}\n'.format(fielddisplay(self, 'istransition','do we use standard [0, default] or transition model [1]'))
-        return string
+        return s
     # }}}
 
@@ -96,9 +101,10 @@
     def setdefaultparameters(self):  # {{{
         # Sheet parameters
-        self.pressure_melt_coefficient = 7.5e-8  #K / Pa (See table 1 in Erder et al. 2013)
+        self.pressure_melt_coefficient = 7.5e-8  #K / Pa (See table 1 in Werder et al. 2013)
         self.cavity_spacing = 2.  #m
-        self.sheet_alpha = 5.0/4.0;
-        self.sheet_beta = 3.0/2.0;
-        self.omega = 1./2000.; 
+        self.sheet_alpha = 5.0/4.0
+        self.sheet_beta = 3.0/2.0
+        self.omega = 1./2000. 
+        self.creep_open_flag = 1
 
         # Channel parameters
@@ -106,6 +112,6 @@
         self.channel_conductivity = 5.e-2  #Dow's default, Table uses 0.1
         self.channel_sheet_width = 2.  #m
-        self.channel_alpha = 5.0/4.0;
-        self.channel_beta = 3.0/2.0;
+        self.channel_alpha = 5.0/4.0
+        self.channel_beta = 3.0/2.0
 
         # Other
@@ -128,7 +134,10 @@
         md = checkfield(md, 'fieldname', 'hydrology.cavity_spacing', 'numel', [1], '>', 0)
         md = checkfield(md, 'fieldname', 'hydrology.bump_height', 'size', [md.mesh.numberofvertices], '>=', 0, 'np.nan', 1, 'Inf', 1)
-        md = checkfield(md,'fieldname','hydrology.omega', 'numel', [1], '>=', 0); 
-        md = checkfield(md,'fieldname','hydrology.sheet_alpha', 'numel', [1], '>', 0); 
-        md = checkfield(md,'fieldname','hydrology.sheet_beta', 'numel', [1], '>', 0); 
+        md = checkfield(md,'fieldname','hydrology.omega', 'numel', [1], '>=', 0) 
+        md = checkfield(md,'fieldname','hydrology.sheet_alpha', 'numel', [1], '>', 0) 
+        md = checkfield(md,'fieldname','hydrology.sheet_beta', 'numel', [1], '>', 0) 
+        md = checkfield(md,'fieldname','hydrology.rheology_B_base', 'size', [md.mesh.numberofvertices], '>=', 0, 'np.nan', 1, 'Inf', 1)
+        md = checkfield(md, 'fieldname', 'hydrology.isincludesheetthickness', 'numel', [1], 'values', [0, 1])
+        md = checkfield(md, 'fieldname', 'hydrology.creep_open_flag', 'numel', [1], 'values', [0, 1])
         md = checkfield(md,'fieldname','hydrology.rheology_B_base', 'size', [md.mesh.numberofvertices], '>=', 0, 'np.nan', 1, 'Inf', 1)
 
@@ -137,6 +146,6 @@
         md = checkfield(md, 'fieldname', 'hydrology.channel_conductivity', 'size', [md.mesh.numberofvertices], '>', 0)
         md = checkfield(md, 'fieldname', 'hydrology.channel_sheet_width', 'numel', [1], '>=', 0)
-        md = checkfield(md,'fieldname','hydrology.channel_alpha', 'numel', [1], '>', 0); 
-        md = checkfield(md,'fieldname','hydrology.channel_beta', 'numel', [1], '>', 0); 
+        md = checkfield(md,'fieldname','hydrology.channel_alpha', 'numel', [1], '>', 0) 
+        md = checkfield(md,'fieldname','hydrology.channel_beta', 'numel', [1], '>', 0) 
 
         # Other
@@ -162,7 +171,10 @@
         WriteData(fid, prefix, 'object', self, 'class', 'hydrology', 'fieldname', 'cavity_spacing', 'format', 'Double')
         WriteData(fid, prefix, 'object', self, 'class', 'hydrology', 'fieldname', 'bump_height', 'format', 'DoubleMat', 'mattype', 1)
-        WriteData(fid,prefix,'object',self,'class','hydrology','fieldname','omega','format','Double'); 
-        WriteData(fid,prefix,'object',self,'class','hydrology','fieldname','sheet_alpha','format','Double'); 
-        WriteData(fid,prefix,'object',self,'class','hydrology','fieldname','sheet_beta','format','Double'); 
+        WriteData(fid,prefix,'object',self,'class','hydrology','fieldname','omega','format','Double') 
+        WriteData(fid,prefix,'object',self,'class','hydrology','fieldname','sheet_alpha','format','Double') 
+        WriteData(fid,prefix,'object',self,'class','hydrology','fieldname','sheet_beta','format','Double') 
+        WriteData(fid,prefix,'object',self,'class','hydrology','fieldname','rheology_B_base','format','DoubleMat', 'mattype', 1)
+        WriteData(fid, prefix, 'object', self, 'class', 'hydrology', 'fieldname', 'isincludesheetthickness', 'format', 'Boolean')
+        WriteData(fid, prefix, 'object', self, 'class', 'hydrology', 'fieldname', 'creep_open_flag', 'format', 'Boolean')
         WriteData(fid,prefix,'object',self,'class','hydrology','fieldname','rheology_B_base','format','DoubleMat', 'mattype', 1);
 
@@ -171,6 +183,6 @@
         WriteData(fid, prefix, 'object', self, 'class', 'hydrology', 'fieldname', 'channel_conductivity', 'format', 'DoubleMat', 'mattype', 1)
         WriteData(fid, prefix, 'object', self, 'class', 'hydrology', 'fieldname', 'channel_sheet_width', 'format', 'Double')
-        WriteData(fid,prefix,'object',self,'class','hydrology','fieldname','channel_alpha','format','Double'); 
-        WriteData(fid,prefix,'object',self,'class','hydrology','fieldname','channel_beta','format','Double'); 
+        WriteData(fid,prefix,'object',self,'class','hydrology','fieldname','channel_alpha','format','Double') 
+        WriteData(fid,prefix,'object',self,'class','hydrology','fieldname','channel_beta','format','Double') 
 
         # Others